QCPGraph Class Reference

· · ·
Public Types | Public Functions | Signals | Protected Types | Protected Functions
QCPGraph Class Reference

A plottable representing a graph in a plot. More...

Inheritance diagram for QCPGraph:

## Public Types
enum | LineStyle
enum | ErrorType

## Public Functions
| QCPGraph (QCPAxis *keyAxis, QCPAxis *valueAxis)
const QCPDataMap * | data () const
LineStyle | lineStyle () const
QCPScatterStyle | scatterStyle () const
ErrorType | errorType () const
QPen | errorPen () const
double | errorBarSize () const
bool | errorBarSkipSymbol () const
QCPGraph * | channelFillGraph () const
void | setData (QCPDataMap *data, bool copy=false)
void | setData (const QVector< double > &key, const QVector< double > &value)
void | setDataKeyError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyError)
void | setDataKeyError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyErrorMinus, const QVector< double > &keyErrorPlus)
void | setDataValueError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &valueError)
void | setDataValueError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &valueErrorMinus, const QVector< double > &valueErrorPlus)
void | setDataBothError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyError, const QVector< double > &valueError)
void | setDataBothError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyErrorMinus, const QVector< double > &keyErrorPlus, const QVector< double > &valueErrorMinus, const QVector< double > &valueErrorPlus)
void | setLineStyle (LineStyle ls)
void | setScatterStyle (const QCPScatterStyle &style)
void | setErrorType (ErrorType errorType)
void | setErrorPen (const QPen &pen)
void | setErrorBarSize (double size)
void | setErrorBarSkipSymbol (bool enabled)
void | setChannelFillGraph (QCPGraph *targetGraph)
void | addData (const QCPDataMap &dataMap)
void | addData (const QCPData &data)
void | addData (double key, double value)
void | addData (const QVector< double > &keys, const QVector< double > &values)
void | removeDataBefore (double key)
void | removeDataAfter (double key)
void | removeData (double fromKey, double toKey)
void | removeData (double key)
virtual void | clearData ()
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
void | rescaleAxes (bool onlyEnlarge, bool includeErrorBars) const
void | rescaleKeyAxis (bool onlyEnlarge, bool includeErrorBars) const
void | rescaleValueAxis (bool onlyEnlarge, bool includeErrorBars) const
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
bool | antialiasedErrorBars () const
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
bool | selectable () const
bool | selected () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setAntialiasedErrorBars (bool enabled)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
virtual bool | addToLegend ()
virtual bool | removeFromLegend () const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false) const
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Signals
void | selectionChanged (bool selected)

## Protected Types
enum | SignDomain

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
virtual QCPRange | getKeyRange (bool &validRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getValueRange (bool &validRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getKeyRange (bool &validRange, SignDomain inSignDomain, bool includeErrors) const
virtual QCPRange | getValueRange (bool &validRange, SignDomain inSignDomain, bool includeErrors) const
virtual void | drawFill (QCPPainter *painter, QVector< QPointF > *lineData) const
virtual void | drawScatterPlot (QCPPainter *painter, QVector< QCPData > *pointData) const
virtual void | drawLinePlot (QCPPainter *painter, QVector< QPointF > *lineData) const
virtual void | drawImpulsePlot (QCPPainter *painter, QVector< QPointF > *lineData) const
void | getPlotData (QVector< QPointF > *lineData, QVector< QCPData > *pointData) const
void | getScatterPlotData (QVector< QCPData > *pointData) const
void | getLinePlotData (QVector< QPointF > *lineData, QVector< QCPData > *pointData) const
void | getStepLeftPlotData (QVector< QPointF > *lineData, QVector< QCPData > *pointData) const
void | getStepRightPlotData (QVector< QPointF > *lineData, QVector< QCPData > *pointData) const
void | getStepCenterPlotData (QVector< QPointF > *lineData, QVector< QCPData > *pointData) const
void | getImpulsePlotData (QVector< QPointF > *lineData, QVector< QCPData > *pointData) const
void | drawError (QCPPainter *painter, double x, double y, const QCPData &data) const
void | getVisibleDataBounds (QCPDataMap::const_iterator &lower, QCPDataMap::const_iterator &upper, int &count) const
void | addFillBasePoints (QVector< QPointF > *lineData) const
void | removeFillBasePoints (QVector< QPointF > *lineData) const
QPointF | lowerFillBasePoint (double lowerKey) const
QPointF | upperFillBasePoint (double upperKey) const
const QPolygonF | getChannelFillPolygon (const QVector< QPointF > *lineData) const
int | findIndexBelowX (const QVector< QPointF > *data, double x) const
int | findIndexAboveX (const QVector< QPointF > *data, double x) const
int | findIndexBelowY (const QVector< QPointF > *data, double y) const
int | findIndexAboveY (const QVector< QPointF > *data, double y) const
double | pointDistance (const QPointF &pixelPoint) const
virtual QRect | clipRect () const
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
QPen | mainPen () const
QBrush | mainBrush () const
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
void | applyErrorBarsAntialiasingHint (QCPPainter *painter) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Detailed Description

A plottable representing a graph in a plot.

Usually QCustomPlot creates graphs internally via QCustomPlot::addGraph and the resulting instance is accessed via QCustomPlot::graph.

To plot data, assign it with the setData or addData functions.

Graphs are used to display single-valued data. Single-valued means that there should only be one data point per unique key coordinate. In other words, the graph can't have loops. If you do want to plot non-single-valued curves, rather use the QCPCurve plottable.

# Changing the appearance

The appearance of the graph is mainly determined by the line style, scatter style, brush and pen of the graph (setLineStyle, setScatterStyle, setBrush, setPen).

## Filling under or between graphs

QCPGraph knows two types of fills: Normal graph fills towards the zero-value-line parallel to the key axis of the graph, and fills between two graphs, called channel fills. To enable a fill, just set a brush with setBrush which is neither Qt::NoBrush nor fully transparent.

By default, a normal fill towards the zero-value-line will be drawn. To set up a channel fill between this graph and another one, call setChannelFillGraph with the other graph as parameter.

See Also
  QCustomPlot::addGraph, QCustomPlot::graph, QCPLegend::addGraph

## Member Enumeration Documentation

enum QCPGraph::LineStyle

Defines how the graph's line is represented visually in the plot. The line is drawn with the current pen of the graph (setPen).

See Also
  setLineStyle

Enumerator:

  lsNone | data points are not connected with any lines (e.g. data only represented with symbols according to the scatter style, see setScatterStyle)
  lsLine | data points are connected by a straight line
  lsStepLeft | line is drawn as steps where the step height is the value of the left data point
  lsStepRight | line is drawn as steps where the step height is the value of the right data point
  lsStepCenter | line is drawn as steps where the step is in between two data points
  lsImpulse | each data point is represented by a line parallel to the value axis, which reaches from the data point to the zero-value-line

enum QCPGraph::ErrorType

Defines what kind of error bars are drawn for each data point

Enumerator:

  etNone | No error bars are shown.
  etKey | Error bars for the key dimension of the data point are shown.
  etValue | Error bars for the value dimension of the data point are shown.
  etBoth | Error bars for both key and value dimensions of the data point are shown.

enum QCPAbstractPlottable::SignDomain
| protectedinherited

Represents negative and positive sign domain for passing to getKeyRange and getValueRange.

Enumerator:

  sdNegative | The negative sign domain, i.e. numbers smaller than zero.
  sdBoth | Both sign domains, including zero, i.e. all (rational) numbers.
  sdPositive | The positive sign domain, i.e. numbers greater than zero.

## Constructor & Destructor Documentation

QCPGraph::QCPGraph | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a graph which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The constructed QCPGraph can be added to the plot with QCustomPlot::addPlottable, QCustomPlot then takes ownership of the graph.

To directly create a graph inside a plot, you can also use the simpler QCustomPlot::addGraph function.

## Member Function Documentation

void QCPGraph::setData | ( | QCPDataMap * | data,
|  | bool | copy = `false`
| ) |  |

Replaces the current data with the provided data.

If copy is set to true, data points in data will only be copied. if false, the graph takes ownership of the passed data and replaces the internal data pointer with it. This is significantly faster than copying for large datasets.

void QCPGraph::setData | ( | const QVector< double > & | key,
|  | const QVector< double > & | value
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in key and value pairs. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setDataKeyError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyError
| ) |  |

Replaces the current data with the provided points in key and value pairs. Additionally the symmetrical key error of the data points are set to the values in keyError. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

For asymmetrical errors (plus different from minus), see the overloaded version of this function.

void QCPGraph::setDataKeyError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyErrorMinus,
|  | const QVector< double > & | keyErrorPlus
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in key and value pairs. Additionally the negative key error of the data points are set to the values in keyErrorMinus, the positive key error to keyErrorPlus. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setDataValueError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | valueError
| ) |  |

Replaces the current data with the provided points in key and value pairs. Additionally the symmetrical value error of the data points are set to the values in valueError. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

For asymmetrical errors (plus different from minus), see the overloaded version of this function.

void QCPGraph::setDataValueError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | valueErrorMinus,
|  | const QVector< double > & | valueErrorPlus
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in key and value pairs. Additionally the negative value error of the data points are set to the values in valueErrorMinus, the positive value error to valueErrorPlus. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setDataBothError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyError,
|  | const QVector< double > & | valueError
| ) |  |

Replaces the current data with the provided points in key and value pairs. Additionally the symmetrical key and value errors of the data points are set to the values in keyError and valueError. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

For asymmetrical errors (plus different from minus), see the overloaded version of this function.

void QCPGraph::setDataBothError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyErrorMinus,
|  | const QVector< double > & | keyErrorPlus,
|  | const QVector< double > & | valueErrorMinus,
|  | const QVector< double > & | valueErrorPlus
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in key and value pairs. Additionally the negative key and value errors of the data points are set to the values in keyErrorMinus and valueErrorMinus. The positive key and value errors are set to the values in keyErrorPlus valueErrorPlus. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setLineStyle | ( | LineStyle | ls | ) |

Sets how the single data points are connected in the plot. For scatter-only plots, set ls to lsNone and setScatterStyle to the desired scatter style.

See Also
  setScatterStyle

void QCPGraph::setScatterStyle | ( | const QCPScatterStyle & | style | ) |

Sets the visual appearance of single data points in the plot. If set to QCPScatterStyle::ssNone, no scatter points are drawn (e.g. for line-only-plots with appropriate line style).

See Also
  QCPScatterStyle, setLineStyle

void QCPGraph::setErrorType | ( | ErrorType | errorType | ) |

Sets which kind of error bars (Key Error, Value Error or both) should be drawn on each data point. If you set errorType to something other than etNone, make sure to actually pass error data via the specific setData functions along with the data points (e.g. setDataValueError, setDataKeyError, setDataBothError).

See Also
  ErrorType

void QCPGraph::setErrorPen | ( | const QPen & | pen | ) |

Sets the pen with which the error bars will be drawn.

See Also
  setErrorBarSize, setErrorType

void QCPGraph::setErrorBarSize | ( | double | size | ) |

Sets the width of the handles at both ends of an error bar in pixels.

void QCPGraph::setErrorBarSkipSymbol | ( | bool | enabled | ) |

If enabled is set to true, the error bar will not be drawn as a solid line under the scatter symbol but leave some free space around the symbol.

This feature uses the current scatter size (QCPScatterStyle::setSize) to determine the size of the area to leave blank. So when drawing Pixmaps as scatter points (QCPScatterStyle::ssPixmap), the scatter size must be set manually to a value corresponding to the size of the Pixmap, if the error bars should leave gaps to its boundaries.

setErrorType, setErrorBarSize, setScatterStyle

void QCPGraph::setChannelFillGraph | ( | QCPGraph * | targetGraph | ) |

Sets the target graph for filling the area between this graph and targetGraph with the current brush (setBrush).

When targetGraph is set to 0, a normal graph fill to the zero-value-line will be shown. To disable any filling, set the brush to Qt::NoBrush.

See Also
  setBrush

void QCPGraph::addData | ( | const QCPDataMap & | dataMap | ) |

Adds the provided data points in dataMap to the current data.

See Also
  removeData

void QCPGraph::addData | ( | const QCPData & | data | ) |

This is an overloaded function.

Adds the provided single data point in data to the current data.

See Also
  removeData

void QCPGraph::addData | ( | double | key,
|  | double | value
| ) |  |

This is an overloaded function.

Adds the provided single data point as key and value pair to the current data.

See Also
  removeData

void QCPGraph::addData | ( | const QVector< double > & | keys,
|  | const QVector< double > & | values
| ) |  |

This is an overloaded function.

Adds the provided data points as key and value pairs to the current data.

See Also
  removeData

void QCPGraph::removeDataBefore | ( | double | key | ) |

Removes all data points with keys smaller than key.

See Also
  addData, clearData

void QCPGraph::removeDataAfter | ( | double | key | ) |

Removes all data points with keys greater than key.

See Also
  addData, clearData

void QCPGraph::removeData | ( | double | fromKey,
|  | double | toKey
| ) |  |

Removes all data points with keys between fromKey and toKey. if fromKey is greater or equal to toKey, the function does nothing. To remove a single data point with known key, use removeData(double key).

See Also
  addData, clearData

void QCPGraph::removeData | ( | double | key | ) |

This is an overloaded function.

Removes a single data point at key. If the position is not known with absolute precision, consider using removeData(double fromKey, double toKey) with a small fuzziness interval around the suspected position, depeding on the precision with which the key is known.

See Also
  addData, clearData

void QCPGraph::clearData | ( |  | ) |
| virtual

Removes all data points.

See Also
  removeData, removeDataAfter, removeDataBefore

Implements QCPAbstractPlottable.

double QCPGraph::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the item is represented not by single lines but by an area like QCPItemRect or QCPItemText, a click inside the area returns a constant value greater zero (typically the selectionTolerance of the parent QCustomPlot multiplied by 0.99). If the click lies outside the area, this function returns -1.0.

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See Also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractPlottable.

void QCPGraph::rescaleAxes | ( | bool | onlyEnlarge,
|  | bool | includeErrorBars
| ) |  | const

This is an overloaded function.

Allows to define whether error bars are taken into consideration when determining the new axis range.

See Also
  rescaleKeyAxis, rescaleValueAxis, QCPAbstractPlottable::rescaleAxes, QCustomPlot::rescaleAxes

void QCPGraph::rescaleKeyAxis | ( | bool | onlyEnlarge,
|  | bool | includeErrorBars
| ) |  | const

This is an overloaded function.

Allows to define whether error bars (of kind QCPGraph::etKey) are taken into consideration when determining the new axis range.

See Also
  rescaleAxes, QCPAbstractPlottable::rescaleKeyAxis

void QCPGraph::rescaleValueAxis | ( | bool | onlyEnlarge,
|  | bool | includeErrorBars
| ) |  | const

This is an overloaded function.

Allows to define whether error bars (of kind QCPGraph::etValue) are taken into consideration when determining the new axis range.

See Also
  rescaleAxes, QCPAbstractPlottable::rescaleValueAxis

void QCPGraph::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPAbstractPlottable.

void QCPGraph::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedvirtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

Implements QCPAbstractPlottable.

QCPRange QCPGraph::getKeyRange | ( | bool & | validRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data key bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). validRange is an output parameter that indicates whether a proper range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

See Also
  rescaleAxes, getValueRange

Implements QCPAbstractPlottable.

QCPRange QCPGraph::getValueRange | ( | bool & | validRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data value bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). validRange is an output parameter that indicates whether a proper range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

See Also
  rescaleAxes, getKeyRange

Implements QCPAbstractPlottable.

QCPRange QCPGraph::getKeyRange | ( | bool & | validRange,
|  | SignDomain | inSignDomain,
|  | bool | includeErrors
| ) |  | const
| protectedvirtual

This is an overloaded function.

Allows to specify whether the error bars should be included in the range calculation.

See Also
  getKeyRange(bool &validRange, SignDomain inSignDomain)

QCPRange QCPGraph::getValueRange | ( | bool & | validRange,
|  | SignDomain | inSignDomain,
|  | bool | includeErrors
| ) |  | const
| protectedvirtual

This is an overloaded function.

Allows to specify whether the error bars should be included in the range calculation.

See Also
  getValueRange(bool &validRange, SignDomain inSignDomain)

void QCPGraph::drawFill | ( | QCPPainter * | painter,
|  | QVector< QPointF > * | lineData
| ) |  | const
| protectedvirtual

Draws the fill of the graph with the specified brush.

If the fill is a normal fill towards the zero-value-line, only the lineData is required (and two extra points at the zero-value-line, which are added by addFillBasePoints and removed by removeFillBasePoints after the fill drawing is done).

If the fill is a channel fill between this QCPGraph and another QCPGraph (mChannelFillGraph), the more complex polygon is calculated with the getChannelFillPolygon function.

See Also
  drawLinePlot

void QCPGraph::drawScatterPlot | ( | QCPPainter * | painter,
|  | QVector< QCPData > * | pointData
| ) |  | const
| protectedvirtual

Draws scatter symbols at every data point passed in pointData. scatter symbols are independent of the line style and are always drawn if the scatter style's shape is not QCPScatterStyle::ssNone. Hence, the pointData vector is outputted by all "get(...)PlotData" functions, together with the (line style dependent) line data.

See Also
  drawLinePlot, drawImpulsePlot

void QCPGraph::drawLinePlot | ( | QCPPainter * | painter,
|  | QVector< QPointF > * | lineData
| ) |  | const
| protectedvirtual

Draws line graphs from the provided data. It connects all points in lineData, which was created by one of the "get(...)PlotData" functions for line styles that require simple line connections between the point vector they create. These are for example getLinePlotData, getStepLeftPlotData, getStepRightPlotData and getStepCenterPlotData.

See Also
  drawScatterPlot, drawImpulsePlot

void QCPGraph::drawImpulsePlot | ( | QCPPainter * | painter,
|  | QVector< QPointF > * | lineData
| ) |  | const
| protectedvirtual

Draws impulses from the provided data, i.e. it connects all line pairs in lineData, which was created by getImpulsePlotData.

See Also
  drawScatterPlot, drawLinePlot

void QCPGraph::getPlotData | ( | QVector< QPointF > * | lineData,
|  | QVector< QCPData > * | pointData
| ) |  | const
| protected

This function branches out to the line style specific "get(...)PlotData" functions, according to the line style of the graph.

lineData will be filled with raw points that will be drawn with the according draw functions, e.g. drawLinePlot and drawImpulsePlot. These aren't necessarily the original data points, since for step plots for example, additional points are needed for drawing lines that make up steps. If the line style of the graph is lsNone, the lineData vector will be left untouched.

pointData will be filled with the original data points so drawScatterPlot can draw the scatter symbols accordingly. If no scatters need to be drawn, i.e. the scatter style's shape is QCPScatterStyle::ssNone, pass 0 as pointData, and this step will be skipped.

See Also
  getScatterPlotData, getLinePlotData, getStepLeftPlotData, getStepRightPlotData, getStepCenterPlotData, getImpulsePlotData

void QCPGraph::getScatterPlotData | ( | QVector< QCPData > * | pointData | ) | const
| protected

If line style is lsNone and the scatter style's shape is not QCPScatterStyle::ssNone, this function serves at providing the visible data points in pointData, so the drawScatterPlot function can draw the scatter points accordingly.

If line style is not lsNone, this function is not called and the data for the scatter points are (if needed) calculated inside the corresponding other "get(...)PlotData" functions.

See Also
  drawScatterPlot

void QCPGraph::getLinePlotData | ( | QVector< QPointF > * | lineData,
|  | QVector< QCPData > * | pointData
| ) |  | const
| protected

Places the raw data points needed for a normal linearly connected graph in lineData.

As for all plot data retrieval functions, pointData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as pointData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getStepLeftPlotData | ( | QVector< QPointF > * | lineData,
|  | QVector< QCPData > * | pointData
| ) |  | const
| protected

Places the raw data points needed for a step plot with left oriented steps in lineData.

As for all plot data retrieval functions, pointData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as pointData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getStepRightPlotData | ( | QVector< QPointF > * | lineData,
|  | QVector< QCPData > * | pointData
| ) |  | const
| protected

Places the raw data points needed for a step plot with right oriented steps in lineData.

As for all plot data retrieval functions, pointData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as pointData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getStepCenterPlotData | ( | QVector< QPointF > * | lineData,
|  | QVector< QCPData > * | pointData
| ) |  | const
| protected

Places the raw data points needed for a step plot with centered steps in lineData.

As for all plot data retrieval functions, pointData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as pointData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getImpulsePlotData | ( | QVector< QPointF > * | lineData,
|  | QVector< QCPData > * | pointData
| ) |  | const
| protected

Places the raw data points needed for an impulse plot in lineData.

As for all plot data retrieval functions, pointData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as pointData, and the function will skip filling the vector.

See Also
  drawImpulsePlot

void QCPGraph::drawError | ( | QCPPainter * | painter,
|  | double | x,
|  | double | y,
|  | const QCPData & | data
| ) |  | const
| protected

called by the scatter drawing function (drawScatterPlot) to draw the error bars on one data point. x and y pixel positions of the data point are passed since they are already known in pixel coordinates in the drawing function, so we save some extra coordToPixel transforms here. data is therefore only used for the errors, not key and value.

void QCPGraph::getVisibleDataBounds | ( | QCPDataMap::const_iterator & | lower,
|  | QCPDataMap::const_iterator & | upper,
|  | int & | count
| ) |  | const
| protected

called by the specific plot data generating functions "get(...)PlotData" to determine which data range is visible, so only that needs to be processed.

lower returns an iterator to the lowest data point that needs to be taken into account when plotting. Note that in order to get a clean plot all the way to the edge of the axes, lower may still be outside the visible range.

upper returns an iterator to the highest data point. Same as before, upper may also lie outside of the visible range.

count number of data points that need plotting, i.e. points between lower and upper, including them. This is useful for allocating the array of `QPointF`s in the specific drawing functions.

if the graph contains no data, count is zero and both lower and upper point to constEnd.

void QCPGraph::addFillBasePoints | ( | QVector< QPointF > * | lineData | ) | const
| protected

The line data vector generated by e.g. getLinePlotData contains only the line that connects the data points. If the graph needs to be filled, two additional points need to be added at the value-zero-line in the lower and upper key positions of the graph. This function calculates these points and adds them to the end of lineData. Since the fill is typically drawn before the line stroke, these added points need to be removed again after the fill is done, with the removeFillBasePoints function.

The expanding of lineData by two points will not cause unnecessary memory reallocations, because the data vector generation functions (getLinePlotData etc.) reserve two extra points when they allocate memory for lineData.

See Also
  removeFillBasePoints, lowerFillBasePoint, upperFillBasePoint

void QCPGraph::removeFillBasePoints | ( | QVector< QPointF > * | lineData | ) | const
| protected

removes the two points from lineData that were added by addFillBasePoints.

See Also
  addFillBasePoints, lowerFillBasePoint, upperFillBasePoint

QPointF QCPGraph::lowerFillBasePoint | ( | double | lowerKey | ) | const
| protected

called by addFillBasePoints to conveniently assign the point which closes the fill polygon on the lower side of the zero-value-line parallel to the key axis. The logarithmic axis scale case is a bit special, since the zero-value-line in pixel coordinates is in positive or negative infinity. So this case is handled separately by just closing the fill polygon on the axis which lies in the direction towards the zero value.

lowerKey will be the the key (in pixels) of the returned point. Depending on whether the key axis is horizontal or vertical, lowerKey will end up as the x or y value of the returned point, respectively.

See Also
  upperFillBasePoint, addFillBasePoints

QPointF QCPGraph::upperFillBasePoint | ( | double | upperKey | ) | const
| protected

called by addFillBasePoints to conveniently assign the point which closes the fill polygon on the upper side of the zero-value-line parallel to the key axis. The logarithmic axis scale case is a bit special, since the zero-value-line in pixel coordinates is in positive or negative infinity. So this case is handled separately by just closing the fill polygon on the axis which lies in the direction towards the zero value.

upperKey will be the the key (in pixels) of the returned point. Depending on whether the key axis is horizontal or vertical, upperKey will end up as the x or y value of the returned point, respectively.

See Also
  lowerFillBasePoint, addFillBasePoints

const QPolygonF QCPGraph::getChannelFillPolygon | ( | const QVector< QPointF > * | lineData | ) | const
| protected

Generates the polygon needed for drawing channel fills between this graph (data passed via lineData) and the graph specified by mChannelFillGraph (data generated by calling its getPlotData function). May return an empty polygon if the key ranges have no overlap or fill target graph and this graph don't have same orientation (i.e. both key axes horizontal or both key axes vertical). For increased performance (due to implicit sharing), keep the returned QPolygonF const.

int QCPGraph::findIndexBelowX | ( | const QVector< QPointF > * | data,
|  | double | x
| ) |  | const
| protected

Finds the highest index of data, whose points x value is just below x. Assumes x values in data points are ordered ascending, as is the case when plotting with horizontal key axis.

Used to calculate the channel fill polygon, see getChannelFillPolygon.

int QCPGraph::findIndexAboveX | ( | const QVector< QPointF > * | data,
|  | double | x
| ) |  | const
| protected

Finds the smallest index of data, whose points x value is just above x. Assumes x values in data points are ordered ascending, as is the case when plotting with horizontal key axis.

Used to calculate the channel fill polygon, see getChannelFillPolygon.

int QCPGraph::findIndexBelowY | ( | const QVector< QPointF > * | data,
|  | double | y
| ) |  | const
| protected

Finds the highest index of data, whose points y value is just below y. Assumes y values in data points are ordered descending, as is the case when plotting with vertical key axis (since keys are ordered ascending).

Used to calculate the channel fill polygon, see getChannelFillPolygon.

int QCPGraph::findIndexAboveY | ( | const QVector< QPointF > * | data,
|  | double | y
| ) |  | const
| protected

Finds the smallest index of data, whose points y value is just above y. Assumes y values in data points are ordered descending, as is the case when plotting with vertical key axis.

Used to calculate the channel fill polygon, see getChannelFillPolygon.

double QCPGraph::pointDistance | ( | const QPointF & | pixelPoint | ) | const
| protected

Calculates the (minimum) distance (in pixels) the graph's representation has from the given pixelPoint in pixels. This is used to determine whether the graph was clicked or not, e.g. in selectTest.

If either the graph has no data or if the line style is lsNone and the scatter style's shape is QCPScatterStyle::ssNone (i.e. there is no visual representation of the graph), returns 500.

void QCPAbstractPlottable::setName | ( | const QString & | name | ) |
| inherited

The name is the textual representation of this plottable as it is displayed in the legend (QCPLegend). It may contain any UTF-8 characters, including newlines.

void QCPAbstractPlottable::setAntialiasedFill | ( | bool | enabled | ) |
| inherited

Sets whether fills of this plottable is drawn antialiased or not.

Note that this setting may be overridden by QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

void QCPAbstractPlottable::setAntialiasedScatters | ( | bool | enabled | ) |
| inherited

Sets whether the scatter symbols of this plottable are drawn antialiased or not.

Note that this setting may be overridden by QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

void QCPAbstractPlottable::setAntialiasedErrorBars | ( | bool | enabled | ) |
| inherited

Sets whether the error bars of this plottable are drawn antialiased or not.

Note that this setting may be overridden by QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

void QCPAbstractPlottable::setPen | ( | const QPen & | pen | ) |
| inherited

The pen is used to draw basic lines that make up the plottable representation in the plot.

For example, the QCPGraph subclass draws its graph lines and scatter points with this pen.

See Also
  setBrush

void QCPAbstractPlottable::setSelectedPen | ( | const QPen & | pen | ) |
| inherited

When the plottable is selected, this pen is used to draw basic lines instead of the normal pen set via setPen.

See Also
  setSelected, setSelectable, setSelectedBrush, selectTest

void QCPAbstractPlottable::setBrush | ( | const QBrush & | brush | ) |
| inherited

The brush is used to draw basic fills of the plottable representation in the plot. The Fill can be a color, gradient or texture, see the usage of QBrush.

For example, the QCPGraph subclass draws the fill under the graph with this brush, when it's not set to Qt::NoBrush.

See Also
  setPen

void QCPAbstractPlottable::setSelectedBrush | ( | const QBrush & | brush | ) |
| inherited

When the plottable is selected, this brush is used to draw fills instead of the normal brush set via setBrush.

See Also
  setSelected, setSelectable, setSelectedPen, selectTest

void QCPAbstractPlottable::setKeyAxis | ( | QCPAxis * | axis | ) |
| inherited

The key axis of a plottable can be set to any axis of a QCustomPlot, as long as it is orthogonal to the plottable's value axis. This function performs no checks to make sure this is the case. The typical mathematical choice is to use the x-axis (QCustomPlot::xAxis) as key axis and the y-axis (QCustomPlot::yAxis) as value axis.

Normally, the key and value axes are set in the constructor of the plottable (or QCustomPlot::addGraph when working with QCPGraphs through the dedicated graph interface).

See Also
  setValueAxis

void QCPAbstractPlottable::setValueAxis | ( | QCPAxis * | axis | ) |
| inherited

The value axis of a plottable can be set to any axis of a QCustomPlot, as long as it is orthogonal to the plottable's key axis. This function performs no checks to make sure this is the case. The typical mathematical choice is to use the x-axis (QCustomPlot::xAxis) as key axis and the y-axis (QCustomPlot::yAxis) as value axis.

Normally, the key and value axes are set in the constructor of the plottable (or QCustomPlot::addGraph when working with QCPGraphs through the dedicated graph interface).

See Also
  setKeyAxis

void QCPAbstractPlottable::setSelectable | ( | bool | selectable | ) |
| inherited

Sets whether the user can (de-)select this plottable by clicking on the QCustomPlot surface. (When QCustomPlot::setInteractions contains iSelectPlottables.)

However, even when selectable was set to false, it is possible to set the selection manually, by calling setSelected directly.

See Also
  setSelected

void QCPAbstractPlottable::setSelected | ( | bool | selected | ) |
| inherited

Sets whether this plottable is selected or not. When selected, it uses a different pen and brush to draw its lines and fills, see setSelectedPen and setSelectedBrush.

The entire selection mechanism for plottables is handled automatically when QCustomPlot::setInteractions contains iSelectPlottables. You only need to call this function when you wish to change the selection state manually.

This function can change the selection state even when setSelectable was set to false.

emits the selectionChanged signal when selected is different from the previous selection state.

See Also
  setSelectable, selectTest

bool QCPAbstractPlottable::addToLegend | ( |  | ) |
| virtualinherited

Adds this plottable to the legend of the parent QCustomPlot (QCustomPlot::legend).

Normally, a QCPPlottableLegendItem is created and inserted into the legend. If the plottable needs a more specialized representation in the legend, this function will take this into account and instead create the specialized subclass of QCPAbstractLegendItem.

Returns true on success, i.e. when the legend exists and a legend item associated with this plottable isn't already in the legend.

See Also
  removeFromLegend, QCPLegend::addItem

bool QCPAbstractPlottable::removeFromLegend | ( |  | ) | const
| virtualinherited

Removes the plottable from the legend of the parent QCustomPlot. This means the QCPAbstractLegendItem (usually a QCPPlottableLegendItem) that is associated with this plottable is removed.

Returns true on success, i.e. if the legend exists and a legend item associated with this plottable was found and removed.

See Also
  addToLegend, QCPLegend::removeItem

void QCPAbstractPlottable::rescaleAxes | ( | bool | onlyEnlarge = `false` | ) | const
| inherited

Rescales the key and value axes associated with this plottable to contain all displayed data, so the whole plottable is visible. If the scaling of an axis is logarithmic, rescaleAxes will make sure not to rescale to an illegal range i.e. a range containing different signs and/or zero. Instead it will stay in the current sign domain and ignore all parts of the plottable that lie outside of that domain.

onlyEnlarge makes sure the ranges are only expanded, never reduced. So it's possible to show multiple plottables in their entirety by multiple calls to rescaleAxes where the first call has onlyEnlarge set to false (the default), and all subsequent set to true.

See Also
  rescaleKeyAxis, rescaleValueAxis, QCustomPlot::rescaleAxes, QCPAxis::rescale

void QCPAbstractPlottable::rescaleKeyAxis | ( | bool | onlyEnlarge = `false` | ) | const
| inherited

Rescales the key axis of the plottable so the whole plottable is visible.

See rescaleAxes for detailed behaviour.

void QCPAbstractPlottable::rescaleValueAxis | ( | bool | onlyEnlarge = `false` | ) | const
| inherited

Rescales the value axis of the plottable so the whole plottable is visible.

Returns true if the axis was actually scaled. This might not be the case if this plottable has an invalid range, e.g. because it has no data points.

See rescaleAxes for detailed behaviour.

void QCPAbstractPlottable::selectionChanged | ( | bool | selected | ) |
| signalinherited

This signal is emitted when the selection state of this plottable has changed to selected, either by user interaction or by a direct call to setSelected.

QRect QCPAbstractPlottable::clipRect | ( |  | ) | const
| protectedvirtualinherited

Returns the clipping rectangle of this layerable object. By default, this is the viewport of the parent QCustomPlot. Specific subclasses may reimplement this function to provide different clipping rects.

The returned clipping rect is set on the painter before the draw function of the respective object is called.

Reimplemented from QCPLayerable.

QCP::Interaction QCPAbstractPlottable::selectionCategory | ( |  | ) | const
| protectedvirtualinherited

Returns the selection category this layerable shall belong to. The selection category is used in conjunction with QCustomPlot::setInteractions to control which objects are selectable and which aren't.

Subclasses that don't fit any of the normal QCP::Interaction values can use QCP::iSelectOther. This is what the default implementation returns.

See Also
  QCustomPlot::setInteractions

Reimplemented from QCPLayerable.

void QCPAbstractPlottable::applyDefaultAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedvirtualinherited

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing plottable lines.

This is the antialiasing state the painter passed to the draw method is in by default.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

See Also
  setAntialiased, applyFillAntialiasingHint, applyScattersAntialiasingHint, applyErrorBarsAntialiasingHint

Implements QCPLayerable.

void QCPAbstractPlottable::selectEvent | ( | QMouseEvent * | event,
|  | bool | additive,
|  | const QVariant & | details,
|  | bool * | selectionStateChanged
| ) |  |
| protectedvirtualinherited

This event is called when the layerable shall be selected, as a consequence of a click by the user. Subclasses should react to it by setting their selection state appropriately. The default implementation does nothing.

event is the mouse event that caused the selection. additive indicates, whether the user was holding the multi-select-modifier while performing the selection (see QCustomPlot::setMultiSelectModifier). if additive is true, the selection state must be toggled (i.e. become selected when unselected and unselected when selected).

Every selectEvent is preceded by a call to selectTest, which has returned positively (i.e. returned a value greater than 0 and less than the selection tolerance of the parent QCustomPlot). The details data you output from selectTest is feeded back via details here. You may use it to transport any kind of information from the selectTest to the possibly subsequent selectEvent. Usually details is used to transfer which part was clicked, if it is a layerable that has multiple individually selectable parts (like QCPAxis). This way selectEvent doesn't need to do the calculation again to find out which part was actually clicked.

selectionStateChanged is an output parameter. If the pointer is non-null, this function must set the value either to true or false, depending on whether the selection state of this layerable was actually changed. For layerables that only are selectable as a whole and not in parts, this is simple: if additive is true, selectionStateChanged must also be set to true, because the selection toggles. If additive is false, selectionStateChanged is only set to true, if the layerable was previously unselected and now is switched to the selected state.

See Also
  selectTest, deselectEvent

Reimplemented from QCPLayerable.

void QCPAbstractPlottable::deselectEvent | ( | bool * | selectionStateChanged | ) |
| protectedvirtualinherited

This event is called when the layerable shall be deselected, either as consequence of a user interaction or a call to QCustomPlot::deselectAll. Subclasses should react to it by unsetting their selection appropriately.

just as in selectEvent, the output parameter selectionStateChanged (if non-null), must return true or false when the selection state of this layerable has changed or not changed, respectively.

See Also
  selectTest, selectEvent

Reimplemented from QCPLayerable.

void QCPAbstractPlottable::coordsToPixels | ( | double | key,
|  | double | value,
|  | double & | x,
|  | double & | y
| ) |  | const
| protectedinherited

Convenience function for transforming a key/value pair to pixels on the QCustomPlot surface, taking the orientations of the axes associated with this plottable into account (e.g. whether key represents x or y).

key and value are transformed to the coodinates in pixels and are written to x and y.

See Also
  pixelsToCoords, QCPAxis::coordToPixel

const QPointF QCPAbstractPlottable::coordsToPixels | ( | double | key,
|  | double | value
| ) |  | const
| protectedinherited

This is an overloaded function.

Returns the input as pixel coordinates in a QPointF.

void QCPAbstractPlottable::pixelsToCoords | ( | double | x,
|  | double | y,
|  | double & | key,
|  | double & | value
| ) |  | const
| protectedinherited

Convenience function for transforming a x/y pixel pair on the QCustomPlot surface to plot coordinates, taking the orientations of the axes associated with this plottable into account (e.g. whether key represents x or y).

x and y are transformed to the plot coodinates and are written to key and value.

See Also
  coordsToPixels, QCPAxis::coordToPixel

void QCPAbstractPlottable::pixelsToCoords | ( | const QPointF & | pixelPos,
|  | double & | key,
|  | double & | value
| ) |  | const
| protectedinherited

This is an overloaded function.

Returns the pixel input pixelPos as plot coordinates key and value.

QPen QCPAbstractPlottable::mainPen | ( |  | ) | const
| protectedinherited

Returns the pen that should be used for drawing lines of the plottable. Returns mPen when the graph is not selected and mSelectedPen when it is.

QBrush QCPAbstractPlottable::mainBrush | ( |  | ) | const
| protectedinherited

Returns the brush that should be used for drawing fills of the plottable. Returns mBrush when the graph is not selected and mSelectedBrush when it is.

void QCPAbstractPlottable::applyFillAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedinherited

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing plottable fills.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

See Also
  setAntialiased, applyDefaultAntialiasingHint, applyScattersAntialiasingHint, applyErrorBarsAntialiasingHint

void QCPAbstractPlottable::applyScattersAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedinherited

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing plottable scatter points.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

See Also
  setAntialiased, applyFillAntialiasingHint, applyDefaultAntialiasingHint, applyErrorBarsAntialiasingHint

void QCPAbstractPlottable::applyErrorBarsAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedinherited

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing plottable error bars.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

See Also
  setAntialiased, applyFillAntialiasingHint, applyScattersAntialiasingHint, applyDefaultAntialiasingHint

double QCPAbstractPlottable::distSqrToLine | ( | const QPointF & | start,
|  | const QPointF & | end,
|  | const QPointF & | point
| ) |  | const
| protectedinherited

Finds the shortest squared distance of point to the line segment defined by start and end.

This function may be used to help with the implementation of the selectTest function for specific plottables.

Note
  This function is identical to QCPAbstractItem::distSqrToLine

QCPLayerable * QCPLayerable::parentLayerable | ( |  | ) | const
| inlineinherited

Returns the parent layerable of this layerable. The parent layerable is used to provide visibility hierarchies in conjunction with the method realVisibility. This way, layerables only get drawn if their parent layerables are visible, too.

Note that a parent layerable is not necessarily also the QObject parent for memory management. Further, a layerable doesn't always have a parent layerable, so this function may return 0.

A parent layerable is set implicitly with when placed inside layout elements and doesn't need to be set manually by the user.

void QCPLayerable::setVisible | ( | bool | on | ) |
| inherited

Sets the visibility of this layerable object. If an object is not visible, it will not be drawn on the QCustomPlot surface, and user interaction with it (e.g. click and selection) is not possible.

bool QCPLayerable::setLayer | ( | QCPLayer * | layer | ) |
| inherited

Sets the layer of this layerable object. The object will be placed on top of the other objects already on layer.

Returns true on success, i.e. if layer is a valid layer.

bool QCPLayerable::setLayer | ( | const QString & | layerName | ) |
| inherited

This is an overloaded function.

Sets the layer of this layerable object by name

Returns true on success, i.e. if layerName is a valid layer name.

void QCPLayerable::setAntialiased | ( | bool | enabled | ) |
| inherited

Sets whether this object will be drawn antialiased or not.

Note that antialiasing settings may be overridden by QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

bool QCPLayerable::realVisibility | ( |  | ) | const
| inherited

Returns whether this layerable is visible, taking possible direct layerable parent visibility into account. This is the method that is consulted to decide whether a layerable shall be drawn or not.

If this layerable has a direct layerable parent (usually set via hierarchies implemented in subclasses, like in the case of QCPLayoutElement), this function returns true only if this layerable has its visibility set to true and the parent layerable's realVisibility returns true.

If this layerable doesn't have a direct layerable parent, returns the state of this layerable's visibility.

void QCPLayerable::parentPlotInitialized | ( | QCustomPlot * | parentPlot | ) |
| protectedvirtualinherited

This function is called by initializeParentPlot, to allow subclasses to react on the setting of a parent plot. This is the case when 0 was passed as parent plot in the constructor, and the parent plot is set at a later time.

For example, QCPLayoutElement/QCPLayout hierarchies may be created independently of any QCustomPlot at first. When they are then added to a layout inside the QCustomPlot, the top level element of the hierarchy gets its parent plot initialized with initializeParentPlot. To propagate the parent plot to all the children of the hierarchy, the top level element then uses this function to pass the parent plot on to its child elements.

The default implementation does nothing.

See Also
  initializeParentPlot

Reimplemented in QCPLegend, and QCPLayoutElement.

void QCPLayerable::initializeParentPlot | ( | QCustomPlot * | parentPlot | ) |
| protectedinherited

Sets the parent plot of this layerable. Use this function once to set the parent plot if you have passed 0 in the constructor. It can not be used to move a layerable from one QCustomPlot to another one.

Note that, unlike when passing a non-null parent plot in the constructor, this function does not make parentPlot the QObject-parent of this layerable. If you want this, call QObject::setParent(parentPlot) in addition to this function.

Further, you will probably want to set a layer (setLayer) after calling this function, to make the layerable appear on the QCustomPlot.

The parent plot change will be propagated to subclasses via a call to parentPlotInitialized so they can react accordingly (e.g. also initialize the parent plot of child layerables, like QCPLayout does).

void QCPLayerable::setParentLayerable | ( | QCPLayerable * | parentLayerable | ) |
| protectedinherited

Sets the parent layerable of this layerable to parentLayerable. Note that parentLayerable does not become the QObject-parent (for memory management) of this layerable.

The parent layerable has influence on the return value of the realVisibility method. Only layerables with a fully visible parent tree will return true for realVisibility, and thus be drawn.

See Also
  realVisibility

bool QCPLayerable::moveToLayer | ( | QCPLayer * | layer,
|  | bool | prepend
| ) |  |
| protectedinherited

Moves this layerable object to layer. If prepend is true, this object will be prepended to the new layer's list, i.e. it will be drawn below the objects already on the layer. If it is false, the object will be appended.

Returns true on success, i.e. if layer is a valid layer.

void QCPLayerable::applyAntialiasingHint | ( | QCPPainter * | painter,
|  | bool | localAntialiased,
|  | QCP::AntialiasedElement | overrideElement
| ) |  | const
| protectedinherited

Sets the QCPainter::setAntialiasing state on the provided painter, depending on the localAntialiased value as well as the overrides QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements. Which override enum this function takes into account is controlled via overrideElement.

The documentation for this class was generated from the following files:

- src/plottables/plottable-graph.h
- src/plottables/plottable-graph.cpp

Generated with Doxygen 1.8.1.2